// pwratl3ctl.h : Declaration of the Cpwratl3ctl

#ifndef __PWRATL3CTL_H_
#define __PWRATL3CTL_H_

#include "resource.h"       // main symbols
#include <atlctl.h>
#include "pwratl3CP.h"

LRESULT FAR PASCAL GetMsgProc(int nCode, WPARAM wParam, LPARAM lParam);
extern HHOOK g_hHook;
extern CAxWindow g_wnd;
extern CComPtr<IWebBrowser2> m_spBrowser;

/////////////////////////////////////////////////////////////////////////////
// Cpwratl3ctl
class ATL_NO_VTABLE Cpwratl3ctl : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<Ipwratl3ctl, &IID_Ipwratl3ctl, &LIBID_PWRATL3Lib>,
	public IDispatchImpl<Ipwratl3ctlUI, &IID_Ipwratl3ctlUI, &LIBID_PWRATL3Lib>,
	public CComControl<Cpwratl3ctl>,
	public IPersistStreamInitImpl<Cpwratl3ctl>,
	public IOleControlImpl<Cpwratl3ctl>,
	public IOleObjectImpl<Cpwratl3ctl>,
	public IOleInPlaceActiveObjectImpl<Cpwratl3ctl>,
	public IViewObjectExImpl<Cpwratl3ctl>,
	public IOleInPlaceObjectWindowlessImpl<Cpwratl3ctl>,
	public IConnectionPointContainerImpl<Cpwratl3ctl>,
	public IPersistStorageImpl<Cpwratl3ctl>,
	public ISpecifyPropertyPagesImpl<Cpwratl3ctl>,
	public IQuickActivateImpl<Cpwratl3ctl>,
	public IDataObjectImpl<Cpwratl3ctl>,
	public IProvideClassInfo2Impl<&CLSID_pwratl3ctl, &DIID__Ipwratl3ctlEvents, &LIBID_PWRATL3Lib>,
	public IPropertyNotifySinkCP<Cpwratl3ctl>,
	public CComCoClass<Cpwratl3ctl, &CLSID_pwratl3ctl>,
	public CProxy_Ipwratl3ctlEvents< Cpwratl3ctl >
{
public:
	Cpwratl3ctl()
	{
		m_bWindowOnly = TRUE;
	}

	~Cpwratl3ctl()
	{
		if(g_hHook)
		{
			UnhookWindowsHookEx(g_hHook);
			g_hHook = NULL;
		}
	}

DECLARE_REGISTRY_RESOURCEID(IDR_PWRATL3CTL)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(Cpwratl3ctl)
	COM_INTERFACE_ENTRY(Ipwratl3ctl)
	COM_INTERFACE_ENTRY(Ipwratl3ctlUI)
	COM_INTERFACE_ENTRY2(IDispatch, Ipwratl3ctl)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()

BEGIN_PROP_MAP(Cpwratl3ctl)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_CONNECTION_POINT_MAP(Cpwratl3ctl)
	CONNECTION_POINT_ENTRY(IID_IPropertyNotifySink)
	CONNECTION_POINT_ENTRY(DIID__Ipwratl3ctlEvents)
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(Cpwratl3ctl)
	MESSAGE_HANDLER(WM_CREATE, OnCreate)
	CHAIN_MSG_MAP(CComControl<Cpwratl3ctl>)
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);



// IViewObjectEx
	DECLARE_VIEW_STATUS(0)

// Ipwratl3ctl
public:

// Ipwratl3ctlUI
public:
	int BSTR2Char(BSTR bstr, char *cstr);
	STDMETHOD(NavigateComplete2)(/*[in]*/IDispatch *pDisp, /*[in]*/VARIANT *URL);
	STDMETHOD(Navigate)(/*[in]*/ BSTR URL,/*[in, optional]*/ VARIANT * Flags,/*[in, optional]*/ VARIANT * TargetFrameName,/*[in, optional]*/ VARIANT * PostData,/*[in, optional]*/ VARIANT * Headers, /*[out, retval]*/ int *retn);
	// Example method called by the HTML to change the <BODY> background color
	STDMETHOD(OnClick)(IDispatch* pdispBody, VARIANT varColor)
	{
        ::MessageBoxA(NULL, "OnClick", "", MB_OK);
		CComQIPtr<IHTMLBodyElement> spBody(pdispBody);
		if (spBody != NULL)
			spBody->put_bgColor(varColor);
		return S_OK;
	}

	LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		g_hHook = SetWindowsHookEx(
									WH_GETMESSAGE, 
									GetMsgProc, 
									NULL, 
									GetCurrentThreadId());
		CAxWindow wnd(m_hWnd);
		g_wnd = wnd;

		HRESULT hr = wnd.CreateControl(IDH_PWRATL3CTL);
		if (SUCCEEDED(hr))
			hr = wnd.SetExternalDispatch(static_cast<Ipwratl3ctlUI*>(this));
		if (SUCCEEDED(hr))
			hr = wnd.QueryControl(IID_IWebBrowser2, (void**)&m_spBrowser);
		return SUCCEEDED(hr) ? 0 : -1;
	}
};

#endif //__PWRATL3CTL_H_
